﻿---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
--------- Written By: R.J Engel of DX Studios, (Belhatite - Horde / Doomhammer) 	 ----------------
--------- All Rights Reserved, No Reproduction without prior written consent from author ----------------
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------

local NAME, S 		= ...
local Title		= "SellGreyRepair"
local Version 		= "18414c"
local cTitle		= "|cff7696bcSell Grey & Repair|r"
local cVersion		= "|cffB7B7B718414c|r"
SellGreyRepair 		= LibStub("AceAddon-3.0"):NewAddon(Title, "AceEvent-3.0", "AceTimer-3.0")
local SGR 		= SellGreyRepair
local ACR 		= LibStub("AceConfigRegistry-3.0")
local ACD 		= LibStub("AceConfigDialog-3.0")
local args 		= {}
local repair_sound	= "Sound/Spells/Armorkitbuffsound.Ogg"
local sellgrey_sound	= "Sound/Interface/Lootcoinsmall.Ogg"
local crop 		= ":64:64:4:60:4:60"
local profile
local moneyFlag, currentMoney

---------------------------------------------------------------------------------------------------------
------------------------- DO NOT CHANGE ANYTHING BELOW THIS LINE UNLESS YOU KNOW ------------------------
------------------------- WHAT YOU'RE DOING, YOU'VE BEEN WARNED! BAD THINGS!!!!! ------------------------
---------------------------------------------------------------------------------------------------------

---------- COLOR TEST CODING ----------------------------------------------------------------------------
local debugger		= false
local red		= "|cffDC143C"
local blue		= "|cff3A5FCD"
local cadet		= "|cff98F5FF"
local green		= "|cff3CB371"
local help		= "|cffE3CF57"
local white		= "|cffFFFAF0"
local debug		= "|cffED9121"
local color		= "|cff599CFF"
local gold		= "|cffFFD700"
local grod		= "|cffFFB90F"
local silver		= "|cffB7B7B7"

local function PrintLine(input,txt)
	if (input ~= nil) then
		color = input
	else
		color = cadet
	end

	if (txt ~= nil) then
		if (color == debug) then
			DEFAULT_CHAT_FRAME:AddMessage( cTitle..debug.." - DEBUG: "..tostring(txt).."|r" )
		else
			DEFAULT_CHAT_FRAME:AddMessage( cTitle..color..": "..tostring(txt).."|r" )
		end
	end
end

local function OutputIt(input,txt)
	if (input ~= nil) then
		color = input
	else
		color = cadet
	end

	if (txt ~= nil) then
		if (color == debug) then
			DEFAULT_CHAT_FRAME:AddMessage( cTitle..debug.." - DEBUG: "..tostring(txt).."|r" )
		else
			DEFAULT_CHAT_FRAME:AddMessage(color.."-----> "..tostring(txt).."|r" )
		end
	end
end

---------------------------------------------------------------------------------------------------------

--------------- SOUND FEATURE ---------------------------------------------------------------------------

function Sound_Off()
	PlaySoundFile(sounding)
end

---------------------------------------------------------------------------------------------------------

--------------- LANGUAGE FEATURE ------------------------------------------------------------------------

local localeStrings = {
	["enUS"] = {
		AD_LOAD		= "Thank you for choosing "..cTitle.." type /sgr to configure.",
		SO_NAME		= "Sound System",
		SO_DESC		= "Enable/Disable the Sound System.",
		SO_ABLE		= "Sound Feature is now Online.",
		SO_DISA		= "Sound Feature is now Offline.",
		SG_NAME		= "Automatic Sell Grey Items",
		SG_DESC		= "Enable/Disable the Auto SellGrey Feature.",
		SG_ABLE		= "Automatic Sell Grey Feature is now Online.",
		SG_DISA		= "Automatic Sell Grey Feature is now Offline.",
		RE_NAME		= "Automatic Repair",
		RE_DESC		= "Enable/Disable the Auto Repair Feature.",
		RE_ABLE		= "Automatic Repair Feature is now Online.",
		RE_DISA		= "Automatic Repair Feature is now Offline.",
		RO_OPT		= "Repair Type",
		RO_DESC		= "Choose from one of the following Repair Options.",
		OWNGOLD 	= "will only repair from Your own Gold.",
		OWNFIRST 	= "will attempt to repair from You own gold first, then will repair from Guild Bank Funds if fails.",
		GFIRST 		= "will attempt to repair from Guild Bank Funds first, then will repair from own Gold if fails.",
		YOU_PAY		= "You paid",
		DID_RE		= "to have your items repaired.",
		YOU_NE		= "You don't have enough Gold to Automatically repair!",
		BANK_PAY	= "Your guild bank paid",
		NO_GUILD	= "You are not in a guild and can't repair with guild funds, type /sgr to change this option, or hold down the [ALT] key to temporarily override and try again.",
		L_CLICK 	= "Left Click to open the options menu.",
		LS_CLICK 	= "Shift-click to Enable/Disable "..cTitle,
		CGO_ABLE	= "is now Active!",
		CGO_DISA	= "is now Disabled!",
		SGR_ABLE	= "Is now Active!", 
		SGR_DISA	= "Is now Deactivated!",
		EARNED1		= "You earned ",
		EARNED2		= " from selling your gray items.",
		SELL_IT		= "Items sold include: ",
		NO_SELL		= "No gray items to sell!",
		SGR_OWN		= "Your own Gold first, then Guild Funds if available.",
		SGRONLY		= "Will Only Use Your Gold.",
		SGR_GLD		= "Guild Funds first then Yours if not enough.",
		G_FAIL		= "Insufficient Guild funds, attempting to repair with your gold.",
		SELLING		= "One moment while we sell grey items to this vendor, then auto repair will complete.",

		SELL_NAME	= "Announce Sold Items",
		SELL_DESC	= "Enable/Disable the announcing of items sold, and the amount you've earned.",
		SELL_ABLE	= "Will now announce items sold and amount earned.",
		SELL_DISA	= "Will NOT announce items sold and amount earned.",
		EARN_NAME	= "Announce Repair Costs",
		EARN_DESC	= "Enable/Disable the announcing of the cost to repair your items.",
		EARN_ABLE	= "Will now announce cost to repair your items.",
		EARN_DISA	= "Will NOT announce cost to repair your items.",
	},

	["esES"] = {
		AD_LOAD		= "Gracias por elegir ".. cTitle .." tipo /sgr configurar.",
		SO_NAME		= "Sistema de Sonido",
		SO_DESC		= "Activar/Desactivar el Sistema de Sonido.",
		SO_ABLE		= "Funcion de sonido esta en línea.",
		SO_DISA		= "Funcion de sonido esta fuera de línea.",
		SG_NAME		= "Auto Venta Articulos Gris",
		SG_DESC		= "Activar/Desactivar la funcion de Venta Gris Automatico.",
		SG_ABLE		= "Funcion automatica Gris Venta esta ahora en linea.",
		SG_DISA		= "Funcion automatica Gris Venta ahora esta fuera de linea.",
		RE_NAME		= "Opciones de Reparacion",
		RE_DESC		= "Elige una de las siguientes opciones de reparacion.",
		RE_ABLE		= "Funcion de reparacion automatica esta ahora en linea.",
		RE_DISA		= "Funcion de reparacion automatica es ahora fuera de linea.",
		RO_OPT		= "Reparacion Tipo",
		RO_DESC		= "Elige una de las siguientes opciones de reparacion.",
		OWNGOLD 	= "Solo se compromete a reparar desde su propio oro.",
		OWNFIRST 	= "Intentara reparar Eres dueno de oro, luego se compromete a reparar los Fondos banco de hermandad si se produce un error.",
		GFIRST 		= "Intentara reparar Gremio de los fondos del Banco, luego se compromete a reparar de Oro cuenta si se produce un error.",
		YOU_PAY		= "Usted pago",
		DID_RE		= "tener los elementos reparados.",
		YOU_NE		= "Usted no tiene suficiente oro para reparar automaticamente!",
		NO_GUILD	= "Usted no esta en un clan y no se puede reparar con fondos del gremio, escriba /sgr de cambiar esta opcion, o mantenga pulsada la tecla [ALT] para anular temporalmente e intentar una vez mas.",
		BANK_PAY	= "Su banco de la hermandad pagado",
		L_CLICK 	= "Clic izquierdo para abrir el menú de opciones.",
		LS_CLICK 	= "Shift + clic izquierdo para Activar/Desactivar "..cTitle,
		CGO_ABLE	= "ya esta Activo!",
		CGO_DISA	= "esta Desactivado!",
		SGR_ABLE	= "Ya esta Activo!!", 
		SGR_DISA	= "Esta Desactivado!!",
		EARNED1		= "Usted gano ",
		EARNED2		= " de la venta de sus articulos de grises.",
		SELL_IT		= "Los productos para vender son: ",
		NO_SELL		= "No hay elementos grises para vender!",
		SGR_OWN		= "Sus propios oro por primera vez, luego Fondos Gremio si estan disponibles.",
		SGRONLY		= "Solo utilizaremos su oro.",
		SGR_GLD		= "Fondos de Guild primero y luego si tu no lo suficiente.",
		G_FAIL		= "La insuficiencia de fondos Gremio, tratando de reparar con su oro.",
		SELLING		= "Un momento mientras que nosotros vendemos grises items este vendedor, luego de reparacion de automoviles se completa.",

		SELL_NAME 	= "Anunciar articulos vendidos",
		SELL_DESC 	= "Activar / Desactivar el anunciar de articulos vendidos, y la cantidad que has ganado.",
		SELL_ABLE 	= "Sera ahora anunciar los articulos vendidos y cantidad ganada.",
		SELL_DISA 	= "No anunciar los articulos vendidos y cantidad ganada.",
		EARN_NAME 	= "Anuncian costos de reparacion",
		EARN_DESC 	= "Activar / Desactivar el anuncio del costo de reparacion de los elementos.",
		EARN_ABLE 	= "Sera ahora anunciar costo de reparacion de los elementos.",
		EARN_DISA 	= "No anunciar costo de reparacion de los elementos.",
	},

	["frFR"] = {
		AD_LOAD		= "Merci d'avoir choisi ".. cTitle .." taper a la machine /sgr a configurer.",
		SO_NAME		= "Sonorisation",
		SO_DESC		= "Activer/Desactiver le Sonorisation.",
		SO_ABLE		= "Caracteristique du son est maintenant en ligne.",
		SO_DISA		= "Caracteristique du son est maintenant hors ligne.",
		SG_NAME		= "Auto Vendre Articles Gris",
		SG_DESC		= "Activer/Desactiver la fonction automatique Vendre Grey.",
		SG_ABLE		= "Automatique Feature Gris Vente est maintenant en ligne.",
		SG_DISA		= "Automatique Feature Gris Vente est maintenant hors ligne.",
		RE_NAME		= "Options de Reparation",
		RE_DESC		= "Choisissez l'une des options de reparation suivantes.",
		RE_ABLE		= "Fonction de Reparation automatique est maintenant en ligne.",
		RE_DISA		= "Fonction de Reparation automatique est maintenant hors ligne.",
		RO_OPT		= "Type de Reparation",
		RO_DESC		= "Choisissez l'une des options de Reparation suivantes.",
		OWNGOLD 	= "Ne reparer de votre propre or.",
		OWNFIRST 	= "Va tenter de reparer a partir d'or Vous possedez premier temps, puis reparer de fonds de la Banque de guilde si echoue.",
		GFIRST 		= "Va tenter de réparer des Fonds Banque de guilde d'abord, puis à réparer de Gold-même si échoue.",
		YOU_PAY		= "Vous avez paye",
		DID_RE		= "d'avoir vos articles repares.",
		YOU_NE		= "Vous n'avez pas assez d'or pour reparer automatiquement!",
		NO_GUILD	= "Vous n'etes pas dans une guilde et ne peut pas reparer avec des fonds de guilde, tapez /sgr de modifier cette option, ou maintenez enfoncee la touche [Alt] pour remplacer temporairement et essayer encore une fois.",
		BANK_PAY	= "Votre banque de guilde payes",
		L_CLICK 	= "Clic gauche pour ouvrir le menu des options.",
		LS_CLICK 	= "Maj + clic gauche pour Activer/Desactiver "..cTitle,
		CGO_ABLE	= "iest maintenant Actif!",
		CGO_DISA	= "est maintenant Desactive!",
		SGR_ABLE	= "iest maintenant Actif!!", 
		SGR_DISA	= "est maintenant Desactive!!",
		EARNED1		= "Vous avez gagne ",
		EARNED2		= " de vendre vos objets gris.",
		SELL_IT		= "Articles a vendre comprennent: ",
		NO_SELL		= "Aucun element gris a vendre!",
		SGR_OWN		= "Vos propres First Gold, Fonds de guilde, puis le cas echeant.",
		SGRONLY		= "N'utiliserons votre or.",
		SGR_GLD		= "Fonds de guilde d'abord, puis a vous, si pas suffisant.",
		G_FAIL		= "Guilde des fonds insuffisants, tentent de reparer avec votre or.",
		SELLING		= "Un moment pendant que nous vendons grises pour objets ce vendeur, puis reparation automobile achevera.",

		SELL_NAME 	= "Annoncer Articles vendus",
		SELL_DESC 	= "Activer / Desactiver l'annonce de produits vendus, et le montant que vous avez gagne.",
		SELL_ABLE 	= "Est-ce que maintenant annoncer items vendus et le montant gagne.",
		SELL_DISA 	= "Ne sera pas annoncer items vendus et le montant gagne.",
		EARN_NAME 	= "Annoncer Couts de reparation",
		EARN_DESC 	= "Activer / Desactiver l'annonce du cout pour reparer vos articles.",
		EARN_ABLE 	= "Est-ce que maintenant annoncer cout pour reparer vos articles.",
		EARN_DISA 	= "N'annoncera pas le cout pour reparer vos articles.",
	},
	["koKR"] = {		-- Thanx to 배병훈 <wowplus2000> For the Korean Translations

		AD_LOAD		= cTitle.."을 선택해 주셔서 감사합니다. :) 옵션 명령어: /sgr",
		SO_NAME		= "수리 시 소리 재생",
		SO_DESC		= "수리할 때 소리를 재생하거나 재생하지 않습니다.",
		SO_ABLE		= "수리할 때 소리를 재생합니다.",
		SO_DISA		= "수리할 때 소리를 재생하지 않습니다.",
		SG_NAME		= "회색 아이템 자동판매",
		SG_DESC		= "회색 아이템 자동판매를 켜거나 끕니다.",
		SG_ABLE		= "상점을 열면 회색 아이템을 자동으로 판매합니다.",
		SG_DISA		= "회색 아이템을 자동으로 판매하지 않습니다.",
		RE_NAME		= "내구도 자동수리",
		RE_DESC		= "내구도 자동수리를 켜거나 끕니다.",
		RE_ABLE		= "수리 가능한 상점을 열면 내구도를 자동으로 수리합니다.",
		RE_DISA		= "내구도를 자동으로 수리하지 않습니다.",
		RO_OPT		= "자동수리 시 비용 계산방법",
		RO_DESC		= "원하시는 비용 계산방법을 선택하세요.",
		OWNGOLD 	= "캐릭터의 소지금으로만 수리비용을 지불합니다.",
		OWNFIRST 	= "소지금으로 수리비용을 지불합니다. (잔액이 부족하면 길드 은행에서 지불)",
		GFIRST 		= "길드 은행에서 수리비용을 지불합니다. (잔액이 부족하면 소지금에서 지불)", 
		YOU_PAY		= "수리비용으로 ",
		DID_RE		= " 만큼 지불하였습니다.",
		YOU_NE		= "자동수리를 하기에는 잔액이 부족하군요. T_T",
		BANK_PAY	= "수리비용으로 길드 은행에서 ",
		NO_GUILD	= "길드에 소속되어 있지 않아 길드 은행에서 수리 비용을 지불할 수 없습니다. 옵션창에서 수리 비용 계산방법을 변경하세요.",
		L_CLICK 	= "마우스 왼쪽클릭으로 설정창을 엽니다.",
		LS_CLICK 	= "시프트-마우스 왼쪽클릭으로 "..cTitle.." 애드온을 활성화 또는 비활성화 합니다.",
		CGO_ABLE	= "애드온이 활성화 되었습니다!",
		CGO_DISA	= "애드온이 비활성화 되었습니다!",
		SGR_ABLE	= "애드온이 활성화 되었습니다!", 
		SGR_DISA	= "애드온이 비활성화 되었습니다!",
		EARNED1		= "아이템을 판매하여 ",
		EARNED2		= " 만큼 획득하였습니다.",
		SELL_IT		= "다음 아이템을 판매하였습니다: ",
		NO_SELL		= "판매할 아이템이 없군요!",
		SGR_OWN		= "소지금으로 수리 (잔액 부족 시 길드 은행에서 지불)",
		SGRONLY		= "소지금으로만 수리",
		SGR_GLD		= "길드 은행에서 수리 (잔액 부족 시 소지금에서 지불)",
		G_FAIL		= "길드 은행 잔액이 부족하여 소지금에서 수리 비용을 지불하였습니다.",
		-- Needs Verification
		SELL_NAME 	= "판매 아이템을 발표",
		SELL_DESC	= "활성화 / 판매 된 제품의 발표를 사용하지 않도록하고, 금액은 적립했습니다.",
		SELL_ABLE	= "지금은 아이템 판매 금액 적립을 발표 할 예정이다.",
		SELL_DISA	= "아이템 판매 금액 적립을 발표하지 않을 것이다.",
		EARN_NAME	= "수리 비용이 발표",
		EARN_DESC	= "아이템을 복구하는 비용의 발표 활성화 / 비활성화합니다.",
		EARN_ABLE	= "이제 항목을 복구하는 비용을 발표 할 예정이다.",
		EARN_DISA	= "아이템을 복구하는 비용을 발표하지 않을 것이다.",
	},
}

local localeInfo 	= localeStrings[GetLocale()] or localeStrings["enUS"]

local SGR_ABLE		= localeInfo.SGR_ABLE
local SGR_DISA		= localeInfo.SGR_DISA
local AD_LOAD		= localeInfo.AD_LOAD
local SO_NAME		= localeInfo.SO_NAME
local SO_DESC		= localeInfo.SO_DESC
local SO_ABLE		= localeInfo.SO_ABLE
local SO_DISA		= localeInfo.SO_DISA
local SG_NAME		= localeInfo.SG_NAME
local SG_DESC		= localeInfo.SG_DESC
local SG_ABLE		= localeInfo.SG_ABLE
local SG_DISA		= localeInfo.SG_DISA
local RE_NAME		= localeInfo.RE_NAME
local RE_DESC		= localeInfo.RE_DESC
local RE_ABLE		= localeInfo.RE_ABLE
local RE_DISA		= localeInfo.RE_DISA
local RO_OPT		= localeInfo.RO_OPT
local RO_DESC		= localeInfo.RO_DESC
local OWNGOLD 		= localeInfo.OWNGOLD 
local OWNFIRST 		= localeInfo.OWNFIRST
local GFIRST 		= localeInfo.GFIRST
local YOU_PAY		= localeInfo.YOU_PAY
local DID_RE		= localeInfo.DID_RE
local YOU_NE		= localeInfo.YOU_NE
local BANK_PAY		= localeInfo.BANK_PAY
local NO_GUILD		= localeInfo.NO_GUILD
local L_CLICK 		= localeInfo.L_CLICK
local LS_CLICK 		= localeInfo.LS_CLICK
local CGO_ABLE		= localeInfo.CGO_ABLE
local CGO_DISA		= localeInfo.CGO_DISA
local EARNED1 		= localeInfo.EARNED1
local EARNED2		= localeInfo.EARNED2
local SELL_IT		= localeInfo.SELL_IT
local NO_SELL		= localeInfo.NO_SELL
local SGR_OWN		= localeInfo.SGR_OWN
local SGRONLY		= localeInfo.SGRONLY
local SGR_GLD		= localeInfo.SGR_GLD
local G_FAIL		= localeInfo.G_FAIL
local SELL_NAME		= localeInfo.SELL_NAME
local SELL_DESC		= localeInfo.SELL_DESC
local SELL_ABLE		= localeInfo.SELL_ABLE
local SELL_DISA		= localeInfo.SELL_DISA
local EARN_NAME		= localeInfo.EARN_NAME
local EARN_DESC		= localeInfo.EARN_DESC
local EARN_ABLE		= localeInfo.EARN_ABLE
local EARN_DISA		= localeInfo.EARN_DISA

SGR.buttonVal 		= { own = SGR_OWN, ownonly = SGRONLY, guild = SGR_GLD}

--------------- END OF LANGUAGE FEATURE -----------------------------------------------------------------
---------------------------------------------------------------------------------------------------------

local events = {
	"MERCHANT_SHOW",
	"VARIABLES_LOADED",
	"PLAYER_QUITING",
	"PLAYER_LEAVING_WORLD",
	"PLAYER_MONEY",
}

local defaults = 	{
				profile = 	{
							SoundSystem		= true,
							SellGreyFeature		= true,
							RepairFeature 		= true,
							RepairOption 		= "ownonly",
							SellGreyRepairOn	= true,
							SGRSellAnnounce		= true,
							SGREarnAnnounce		= true,
						},
			}

function SGR:OnEnable()
	for k, v in pairs(events) do
		if type(v) == "table" then
			for _, event in ipairs(v) do
				self:RegisterEvent(event, k)
			end
		else
			self:RegisterEvent(v)
		end
	end
end

function SGR:OnDisable()
	self:UnregisterAllEvents()
end

function SGR:IsEnabled()
	if (profile.SellGreyRepairOn == true) then
		profile.SellGreyRepairOn = false
		SGR:OnDisable()

	elseif (profile.SellGreyRepairOn == false) then
		profile.SellGreyRepairOn = true
		SGR:OnEnable()
	end
	if (debugger) then
		PrintLine(debug,"SGR:IsEnabled() : "..tostring(profile.SellGreyRepairOn) )
	end
end

local options = {
	type = "group",
	childGroups = "tab",
	name = cTitle .." v. "..cVersion,
	args = {
		main = {
			type 	= "group", 
			order 	= 1,
			name 	= cTitle,
			handler = SGR,
			get 	= "GetValue",
			set 	= "SetValue",
			args = {
				inline1 = {
					type 	= "group", 
					order 	= 1,
					name 	= " ",
					inline 	= true,
					args 	= {
						SoundSystem = {
							name 		= SO_NAME,
							desc 		= SO_DESC,
							type 		= "toggle", 
							order 		= 1,
							width 		= "full",
							get 		= function() return profile.SoundSystem end,
							set 		= 	function(i, v)
											profile.SoundSystem = v
											if (debugger) then
												PrintLine(debug,"SoundSystem :"..tostring(v))
											end
											if (v) then
												PrintLine(help,SO_ABLE)
											else
												PrintLine(help,SO_DISA)
											end
										end,
						},
						SellGreyFeature = {
							name 		= SG_NAME,
							desc 		= SG_DESC,
							type 		= "toggle", 
							order 		= 2,
							width 		= "full",
							set 		= 	function(i, v)
											profile.SellGreyFeature = v
											if (debugger) then
												PrintLine(debug,"SellGrey Feature : "..tostring(v))
											end
											if (v) then
												PrintLine(help,SG_ABLE)
											else
												PrintLine(help,SG_DISA)
											end
										end,
						},
						SGRSellAnnounce = {
							name 		= SELL_NAME,
							desc 		= SELL_DESC,
							type 		= "toggle", 
							order 		= 3,
							width 		= "full",
							get 		= function() return profile.SGRSellAnnounce  end,
							set 		= 	function(i, v)
											profile.SGRSellAnnounce  = v
											if (debugger) then
												PrintLine(debug,"Listing of items sold is :"..tostring(v))
											end
											if (v) then
												PrintLine(help,SELL_ABLE)
											else
												PrintLine(help,SELL_DISA)
											end
										end,
						},
						RepairFeature = {
							name 		= RE_NAME,
							desc 		= RE_DESC,
							type 		= "toggle", 
							order 		= 4,
							width 		= "full",
							set 		= 	function(i, v)
											profile.RepairFeature = v
											if (debugger) then
												PrintLine(debug,"Repair Feature : "..tostring(v))
											end
											if (profile.RepairFeature) then
												PrintLine(help,RE_ABLE)
											else
												PrintLine(help,RE_DISA)
											end
										end,
						},
						SGREarnAnnounce = {
							name 		= EARN_NAME,
							desc 		= EARN_DESC,
							type 		= "toggle", 
							order 		= 5,
							width 		= "full",
							get 		= function() return profile.SGREarnAnnounce  end,
							set 		= 	function(i, v)
											profile.SGREarnAnnounce = v
											if (debugger) then
												PrintLine(debug,"Display of amount earned :"..tostring(v))
											end
											if (v) then
												PrintLine(help,EARN_ABLE)
											else
												PrintLine(help,EARN_DISA)
											end
										end,
						},
						RepairOption = {
							name 		= RO_OPT,
							desc 		= RO_DESC,
							type 		= "select", 
							order 		= 6,
							width 		= "full",
							values 		= SGR.buttonVal,
							get 		= 	function() 
											return profile.RepairOption
										end,
							set 		= 	function(_, btn) 
											profile.RepairOption = btn ~= " " and btn or nil
											if (debugger) then
												PrintLine(debug,profile.RepairOption.." == "..btn) 
											end
											SGRStatus()
										end,
						},
					},
				},
		       },
	       },
	},
}

function Sound_Off( arg1 )
	if (SoundSystem and arg1 ~= "" ) then
    		PlaySoundFile(arg1);
  	end
end

function SGR:GetValue(i)
	if (debugger) then
		PrintLine(debug,tostring(profile[i[#i]]))
	end
	return profile[i[#i]]
end

function SGR:SetValue(i, v)
	profile[i[#i]] = v
	if (debugger) then
		PrintLine(debug,tostring(v))
	end
end

function SGR:RefreshDB()
	profile = self.db.profile
	if (debugger) then
		PrintLine(debug,"Savings Profile Settings.")
	end
end

function SGR:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("SellGreyRepairDB", defaults, true)
	profile = self.db.profile
	self.db.global.version = Version
	self.db.RegisterCallback(self, "OnProfileChanged", "RefreshDB")
	self.db.RegisterCallback(self, "OnProfileCopied", "RefreshDB")
	self.db.RegisterCallback(self, "OnProfileReset", "RefreshDB")
	ACR:RegisterOptionsTable("SellGreyRepair_Parent", options)
	ACR:RegisterOptionsTable("SellGreyRepair_Main", options.args.main)
	options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	ACR:RegisterOptionsTable("SellGreyRepair_Profiles", options.args.profiles)
	ACD:AddToBlizOptions("SellGreyRepair_Parent", NAME)
	ACD:AddToBlizOptions("SellGreyRepair_Main", options.args.main.name, NAME)
	ACD:AddToBlizOptions("SellGreyRepair_Profiles", options.args.profiles.name, NAME)
	ACD:SetDefaultSize("SellGreyRepair_Parent", 610, 520)
	options.args.profiles.order = 2
	PrintLine(color,AD_LOAD)

	if (debugger) then
		PrintLine(debug,"Initializing System.")
	end
end

local enable = {
			["1"] 	= true,
			on 	= true,
			enable 	= true,
			load 	= true,
}

local disable = {
			["0"] 	= true,
			off 	= true,
			disable = true,
			unload 	= true,
}

for i, v in ipairs({"sgr", "sellgrey", "sellgreyrepair"}) do
	_G["SLASH_SellGreyRepair"..i] = "/"..v
end

SlashCmdList.SellGreyRepair = function(msg, editbox)
	if (debugger) then 
		if (msg == "repair") then
			PlaySoundFile(repair_sound)
		elseif (msg == "sell") then
			PlaySoundFile(sellgrey_sound)
		end
		PrintLine(debug,"msg: "..msg.."\nEdit box: "..editbox )
	else
		SGR:RefreshDB()
		PlaySoundFile(repair_sound)
		ACD:Open("SellGreyRepair_Parent")
	end
end

function SGR:PLAYER_LEAVING_WORLD()
	self:RefreshDB()
	if (debugger) then
		PrintLine(debug,"Player Leaving World.")
	end
end

function SGR:PLAYER_MONEY()
	if (debugger) then
		PrintLine(debug,"Updating Player Money.")
	end

	if (moneyFlag) then
		moneyFlag = nil
		local factor = GetMoney() - currentMoney
		if (profile.SGRSellAnnounce == true) then
			OutputIt(yellow, EARNED1..GetCoinTextureString(factor,10)..EARNED2 )
		end
	end
end

function SGR:PLAYER_QUITING()
	if (debugger) then
		PrintLine(debug,"Player Quitting Game.")
	end
	self:RefreshDB()
end

function SGRStatus()
	local modetext	= "";

	if( profile.RepairOption == "own") then
		modetext = OWNFIRST

	elseif( profile.RepairOption == "ownonly") then
		modetext = OWNGOLD

	elseif( profile.RepairOption == "guild") then
		modetext = GFIRST
	end

	PrintLine(help,modetext)

	if (debugger) then
		PrintLine(debug,"Updating Status: "..modetext)
	end
end
---------------------------------------------------------------------------------------

function DoRepair(repairAllCost, canRepair)
	if (debugger) then
		PrintLine(debug,"Do Repair Feature Active.")
	end

	if (canRepair) then
		if (profile.RepairOption == "ownonly") then
			AutoRepair(repairAllCost, canRepair)

		elseif (profile.RepairOption == "own") then
			AutoRepairOwnFirst(repairAllCost, canRepair)

		elseif (profile.RepairOption == "guild") then
			AutoRepairFromBank(repairAllCost, canRepair)
		end

	PlaySoundFile(repair_sound)

	end
end

function AutoRepairOwnFirst(repairAllCost, canRepair) --Added this function
	if (debugger) then
		PrintLine(debug,"Auto Repair Feature Active.")
	end

	if (canRepair and GetMoney() >= repairAllCost) then
		RepairAllItems()
		if (profile.SGREarnAnnounce == true) then
			OutputIt(green,YOU_PAY.." "..GetCoinTextureString(repairAllCost,10).." "..DID_RE)
		end

	elseif (CanGuildBankRepair() and GetGuildBankWithdrawMoney() >= repairAllCost and GetGuildBankMoney() >= repairAllCost) then
		RepairAllItems(1)
		if (profile.SGREarnAnnounce == true) then
			OutputIt(yellow, BANK_PAY.." "..GetCoinTextureString(repairAllCost,10).." "..DID_RE)
		end
	else
		OutputIt(red,YOU_NE)
	end
end

function AutoRepair(repairAllCost, canRepair)
	if (debugger) then
		PrintLine(debug,"Auto Repair Feature Active.")
	end

	if (canRepair and GetMoney() >= repairAllCost) then
		RepairAllItems()
		if (profile.SGREarnAnnounce == true) then
			OutputIt(green,YOU_PAY.." "..GetCoinTextureString(repairAllCost,10).." "..DID_RE)
		end
	else
		OutputIt(red,YOU_NE)
	end
end

function AutoRepairFromBank(repairAllCost, canRepair)
	if (CanGuildBankRepair() and GetGuildBankWithdrawMoney() >= repairAllCost and GetGuildBankMoney() >= repairAllCost) then
		RepairAllItems(1)
		if (profile.SGREarnAnnounce == true) then
			OutputIt(yellow, BANK_PAY.." "..GetCoinTextureString(repairAllCost,10).." "..DID_RE)
		end
 
	else
		if (debugger) then
			PrintLine(debug,"Guild Bank Funding Failed attempting to AutoRepair.")
		end

		OutputIt(red,G_FAIL)
		AutoRepair(repairAllCost, canRepair)
	end
end

---------------------------------------------------------------------------------------

function SellGreyEvent()
	local SellGreySlots,SellGreyLink,SellGreyQuality
	currentMoney = GetMoney()
	local itemTable, isGray = {}

	for bag = 0, 4 do
		for slot = 1, GetContainerNumSlots(bag) do
			if not(GetContainerNumSlots(bag) == nil) then
				SellGreyLink = GetContainerItemLink(bag, slot)

				if not (SellGreyLink == nil) then
					_,_,SellGreyQuality,_,_,_,_,_,_,_,_ = GetItemInfo(SellGreyLink)
					if(SellGreyQuality == 0) then
						isGray = true
						UseContainerItem(bag, slot)
						tinsert(itemTable, SellGreyLink)
					end
				end
			end
		end
	end

	if (isGray) then
		if (profile.SGRSellAnnounce == true) then
			OutputIt(yellow, SELL_IT..strjoin(", ", unpack(itemTable) ) )
		end
		moneyFlag = true
	else
		PrintLine(silver, NO_GREY)
	end
end

function SGR:MERCHANT_SHOW()
	if ( CanMerchantRepair() ) then
		PrintLine(help,SELLING)
		repairAllCost, canRepair 	= GetRepairAllCost()
		SellGreyEvent()
		self:ScheduleTimer(function() DoRepair(repairAllCost, canRepair) end, 3 )
	else
		SellGreyEvent()
	end
end

local dataobject = {
			type = "launcher",
			icon = "Interface\\AddOns\\SellGreyRepair\\sgr.blp",
			text = NAME,
			OnClick = function(clickedframe, button)
				if IsShiftKeyDown() then
					if (profile.SellGreyRepair == false) then
						profile.SellGreyRepair = true
						PrintLine(silver,SGR_ABLE)
						SGR:IsEnabled()
					else
						profile.SellGreyRepair = false
						PrintLine(red,SGR_DISA)
						SGR:IsEnabled()
					end
					if (debugger) then
						PrintLine(debug,"SellGreyRepairOn :"..tostring(profile.SellGreyRepair) )
					end
				else
					ACD[ACD.OpenFrames.SellGreyRepair_Parent and "Close" or "Open"](ACD, "SellGreyRepair_Parent")
				end
			end,

			OnTooltipShow = function(tt)
				tt:AddLine(Title)
				tt:AddLine(white..L_CLICK.."|r")
				tt:AddLine(white..LS_CLICK.."|r")
			end,
}

function SGR:VARIABLES_LOADED()
	SGRStatus()
end

----MUST BE LAST ITEM
LibStub("LibDataBroker-1.1"):NewDataObject(Title, dataobject)